<?php
/**
 * Migration Class
 *
 * @version     1.0.$Revision:$
 * @version     SVN: $Id:$
 * @package     bplan-base/globals
 * @subpackage  Migrations
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 * @copyright   Copyright (C) 2025 bplan-solutions GmbH & Co. KG <https://www.bplan-solutions.de/>
 * /Δ\
 */


use BplanBase\CodeGenerator\Loaders\CodeGenerator;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;


/**
 * Migration Class
 *
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 */
return new class extends Migration
{

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('roles');

    } // down()


    /**
     * Run the migrations.
     */
    public function up(): void
    {
        $tableName = 'roles';

        if (Schema::hasTable($tableName) === false) {
            Schema::create($tableName, function (Blueprint $Table) {
                $Table->id();
                $Table->uuid('uuid');
                $Table->boolean('active')->default(1);

                $Table->timestamp('created_at');
                $Table->timestamp('updated_at');

                $Table->string('guard_name', 125)->default('web');
                $Table->boolean('internal')->default(0);
                $Table->json('labels');
                $Table->string('name', 125);
                $Table->foreignId('tenant_id')->constrained(table: 'tenants', indexName: 'roles_FK_tenant_id');

                $Table->index('tenant_id', 'roles_FKI_tenant_id');

                new CodeGenerator($Table, [
                    'columns' => [
                        'name' => [
                            'sortable' => true,
                        ],
                        'labels' => [
                            'jsonType' => CodeGenerator::JSON_TYPE_LOCALE_OBJECT,
                            'sortable' => true,
                        ],
                    ],
                    'extends' => [
                        'laravel.model' => 'Spatie\\Permission\\Models\\Role as BaseRole',
                    ],
                    'indexQueries' => [
                        'terminal' => '$Query->where(\'active\', \'=\', 1)',
                    ],
                    'routing' => [
                        'terminal' => 'readOnly',
                    ],

                ]);

            });

        }
    } // up()

};
